----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:41:47 04/05/2013 
-- Design Name: 
-- Module Name:    Clockgen - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity FDP_LINK is
	port(	CLK_50MHZ: 	in std_logic;
			DATALVDS_P : OUT std_logic_vector(3 downto 0);
			DATALVDS_N : OUT std_logic_vector(3 downto 0);
			CLKLVDS_P : OUT std_logic;
			CLKLVDS_N : OUT std_logic); 
end FDP_LINK;

architecture STRUCTURE of FDP_LINK is

	--Pixeltakt erzeugen
	COMPONENT pixel_clk
	PORT(
		CLKIN_IN : 			IN std_logic;
		RST_IN : 			IN std_logic;          
		CLKFX_OUT : 		OUT std_logic;
		CLKIN_IBUFG_OUT : OUT std_logic;
		--CLK0_OUT : 			OUT std_logic;
		LOCKED_OUT : 		OUT std_logic
		);
	END COMPONENT;

	COMPONENT top4_tx
	PORT(
		clkin : IN std_logic;
		datain : IN std_logic_vector(27 downto 0);
		rstin : IN std_logic;          
		dataouta_p : OUT std_logic_vector(3 downto 0);
		dataouta_n : OUT std_logic_vector(3 downto 0);
		clkouta1_p : OUT std_logic;
		clkouta1_n : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT patternGen
	PORT(
		RSTIN : IN std_logic;
		CLKIN : IN std_logic;
		INITI : IN std_logic;
		CLKEN : IN std_logic;
		M_SEL : IN std_logic_vector(2 downto 0);          
		ODATA : OUT std_logic_vector(27 downto 0)
		);
	END COMPONENT;

			
	signal reset: 		std_logic;
	signal pxclock: 	std_logic;
	signal pxclockBuf: 	std_logic;
	signal clk0: 		std_logic;
	signal dcm1_lock: std_logic;
	signal ibufg_out: std_logic;
	signal clk35:		std_logic;
	signal dataFromGen: std_logic_vector(27 downto 0);
	signal datout_p: 	std_logic_vector(3 downto 0);
	signal datout_n: 	std_logic_vector(3 downto 0);
	signal clkout_p: 	std_logic;
	signal clkout_n: 	std_logic;
	signal init:		std_logic;
	signal msel: std_logic_vector(2 downto 0);
		

begin

	 				
	--Pixeltakt erzeugen
	Inst_pixel_clk: pixel_clk PORT MAP(
		CLKIN_IN => CLK_50MHZ,
		RST_IN => reset,
		CLKFX_OUT => pxclock,
		CLKIN_IBUFG_OUT => ibufg_out,
		--CLK0_OUT => clk0,
		LOCKED_OUT => dcm1_lock);
		
	--Instantz des Serialisieres	
	Inst_top4_tx: top4_tx PORT MAP(
		clkin => pxclockBuf,
		datain => dataFromGen,
		rstin => reset,
		dataouta_p => datout_p,
		dataouta_n => datout_n,
		clkouta1_p => clkout_p,
		clkouta1_n => clkout_n);
		
	--Mustererzeuger
	Inst_patternGen: patternGen PORT MAP(
		RSTIN => reset,
		CLKIN => pxclockBuf,
		INITI => init,
		CLKEN => dcm1_lock,
		M_SEL => msel,
		ODATA => dataFromGen);


		
init <= '0';
pxclockBuf <= pxclock;
			

DATALVDS_P 	<= 	datout_p;
DATALVDS_N 	<= 	datout_n;
CLKLVDS_P  	<= 	clkout_p;
CLKLVDS_N 	<= 	clkout_n; 


end STRUCTURE;

