------------------------------------------------------------------------------
--
--  Xilinx, Inc. 2004                 www.xilinx.com
--
--  XAPP 486 - 7:1 LVDS in Spartan3E Devices
--
------------------------------------------------------------------------------
--
--  File name :       serdes_4b_7to1_wrapper.vhd
--
--  Description :     Wrapper for generic 4-bit serdes_4b_7to1 for Spartan 3E
--
--  Date - revision : December 15th 2005 - v 1.1
--
--  Author :          NJS
--
--  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
--              provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied,
--              statutory or otherwise, and Xilinx specifically disclaims any
--              implied warranties of merchantability, non-infringement,or
--              fitness for a particular purpose. Xilinx does not warrant that
--              the functions contained in these designs will meet your
--              requirements, or that the operation of these designs will be
--              uninterrupted or error free, or that defects in the Designs
--              will be corrected. Furthermore, Xilinx does not warrantor
--              make any representations regarding use or the results of the
--              use of the designs in terms of correctness, accuracy,
--              reliability, or otherwise.
--
--              LIMITATION OF LIABILITY. In no event will Xilinx or its
--              licensors be liable for any loss of data, lost profits,cost
--              or procurement of substitute goods or services, or for any
--              special, incidental, consequential, or indirect damages
--              arising from the use or operation of the designs or
--              accompanying documentation, however caused and on any theory
--              of liability. This limitation will apply even if Xilinx
--              has been advised of the possibility of such damage. This
--              limitation shall apply not-withstanding the failure of the
--              essential purpose of any limited remedies herein.
--
--  Copyright  2004 Xilinx, Inc.
--  All rights reserved
--
------------------------------------------------------------------------------
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

library unisim ;
use unisim.vcomponents.all ;

entity serdes_4b_7to1_wrapper is port (
	clk 		: in std_logic ;			-- clock
	clkx3p5 	: in std_logic ;			-- 3.5 times clock
	clkx3p5not	: in std_logic ;			-- not 3.5 times clock
	datain 		: in std_logic_vector(27 downto 0) ;	-- input data
	rst 		: in std_logic ;			-- reset
	dataout		: out std_logic_vector(7 downto 0) ;	-- output data
	clkout		: out std_logic_vector(1 downto 0)) ;	-- output clock (1x)
end serdes_4b_7to1_wrapper;

architecture arch_serdes_4b_7to1_wrapper of serdes_4b_7to1_wrapper is

component serdes_4b_7to1 port (
	clk 		: in std_logic ;			-- clock
	clkx3p5 	: in std_logic ;			-- 3.5 times clock
	clkx3p5not	: in std_logic ;			-- not 3.5 times clock
	datain 		: in std_logic_vector(27 downto 0) ;	-- input data
	rst 		: in std_logic ;			-- reset
	dataout		: out std_logic_vector(7 downto 0) ;	-- output data
	clkout		: out std_logic_vector(1 downto 0)) ;	-- output clock (1x)
end component ;

attribute rloc: string ;
attribute rloc of tx0: label is "x0y0" ;

begin

tx0:  serdes_4b_7to1 port map (
	clk 		=> clk,
	clkx3p5 	=> clkx3p5,
	clkx3p5not	=> clkx3p5not,
	datain 		=> datain,
	rst 		=> rst,
	dataout		=> dataout,
	clkout		=> clkout);

end arch_serdes_4b_7to1_wrapper;


